<?php
/**
 * xdump  配合Chrome浏览器插件的xdump调试器
 * @param vars    变量
 *
 * TODO：目前不能获取同一行代码中同时存在两个或者以上xdump的变量名。
 * TODO：浏览器扩展中无法针对URLREWRITE进行调试，需要增加对调试URL的设置。
 * 
 * 使用方法：
 * 1. 非SpeedPHP框架环境下使用，请先定义APP_PATH常量为当前程序的访问URL的物理地址。
 *    比如程序访问地址为http://localhost/myapp/，那么APP_PATH请设置为myapp的物理地址。
 *    由于SpeedPHP框架本身就对APP_PATH进行设置，所以基于SpeedPHP框架的应用程序无需设置APP_PATH。
 * 2. 载入当前文件，使用include或require。而基于SpeedPHP框架的应用程序，可以：
 *    a)放置本文件到框架Extensions目录中，
 *    b)在入口文件处的“require(SP_PATH.'/SpeedPHP.php');”和“spRun();”之间写“import('xdump.php');”。
 *    [code]
 *    require(SP_PATH.'/SpeedPHP.php');
 *    import('xdump.php');
 *    spRun();
 *    [/code]
 * 3. 在程序中需要调试变量的地方，使用xdump(变量名);即可。
 *
 * 说明：
 * 
 * 本扩展由SpeedPHP框架官方提供，为开源代码，可以自由使用。
 * SpeedPHP是一款全功能的国产PHP框架应用系统，速度飞快，上手容易，是最适合初学者的PHP框架。
 * SpeedPHP以“快速开发、快速学习、快速执行”为理念，带你轻松进入PHP高手的行列。
 * 
 * SpeedPHP官方网站 http://speedphp.com
 */
 
// define('APP_PATH', '');

function xdump($vars){
    static $dumpcounter = 0;
	if( defined('SP_PATH') && (TRUE != SP_DEBUG && TRUE != $GLOBALS['G_SP']['allow_trace_onrelease'])){
		@unlink(APP_PATH.'./xdump_debug.html');
		return ;
	}
    if( !defined('APP_PATH') )define('APP_PATH', dirname(__FILE__));
    $backtrace = debug_backtrace();$caller = $backtrace[0];
    $fp = fopen($caller['file'], 'r');
    for ($i = 0; $i < $caller['line']; $i++)$line = fgets($fp);@fclose($fp);
    preg_match('/'.__FUNCTION__.'.*?\((.*?)\)\;/', $line, $matches);
    $varname = $matches[1];
    $content = "<div align=left><pre>\n{$varname}：" . htmlspecialchars(print_r($vars, true)) . "\n</pre></div>\n";
    if( $dumpcounter == 0 ){
            file_put_contents(APP_PATH.'./xdump_debug.html', '<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"></head><body>'.$content.'</body></html>');
    }else{
            $debugtxt = file_get_contents(APP_PATH.'./xdump_debug.html');
            if( strlen($debugtxt) > 1 )$debugtxt = substr($debugtxt, 0, -14);
            file_put_contents(APP_PATH.'./xdump_debug.html', $debugtxt.$content.'</body></html>');
    }
    $dumpcounter = 1;
}